import javax.swing.JOptionPane;
import java.io.IOException;
import java.io.DataOutputStream;
import java.io.FileOutputStream;
import java.io.DataInputStream;
import java.io.FileInputStream;

/**
 * Quiz solution for the DataInputStream and DataOutputStream classes.
 * 
 * @author Prof. Struck
 * @version 12/4/2017
 */
public class DataIOStream
{
    /**
     * Writes product data to a DataOutputStream disk file.
     */
    public static void output()
    {
        try
        {
            DataOutputStream outFile = new DataOutputStream( new FileOutputStream("product.data") );
                    
            for (int ctr = 0; ctr < 3; ctr++)
            {
                outFile.writeInt( Integer.parseInt( JOptionPane.showInputDialog("Product ID:") ) );
                
                outFile.writeUTF( JOptionPane.showInputDialog("Item:") );
                
                outFile.writeDouble( Double.parseDouble( JOptionPane.showInputDialog("Price:") ) );
            }
            
            outFile.close();
        }
        catch (IOException ex)
        {
            System.out.println("File not saved");
        }
    }
    
    /**
     * Reads a product file from disk and displays contents in an output dialog window.
     */
    public static void input()
    {
        try
        {
            StringBuilder output = new StringBuilder();
            DataInputStream input = new DataInputStream( new FileInputStream("product.data") );
            
            for (int ctr = 0; ctr < 3; ctr++)
            {
                output.append("Product ID: ");
                output.append( input.readInt() );
                
                output.append("\nItem: ");
                output.append( input.readUTF() );
                
                output.append("\nPrice: ");
                output.append( input.readDouble() );
                output.append("\n\n");
            }
            
            JOptionPane.showMessageDialog(null, output);
        }
        
        catch (IOException ex)
        {
            System.out.println("File not found");
        }
    }
}
