package randomio;

import java.util.Scanner;
import java.io.RandomAccessFile;
import java.io.IOException;
import java.util.InputMismatchException;

/**
 * Writes and reads 'credits' data to and from a binary RandomAccessFile.
 *
 * @author Carl B. Struck
 * @version  Copyright 2005 (c) SCCC West
 */
public class RandomIO
{
    /**
     * @param args the command line arguments
     */
    private static final Scanner READER = new Scanner(System.in);

    /**
     * Main menu program to input and output RandomAccessFile records.
     *
     * @param args the String[] array command line arguments
     */
    public static void main(String[] args)
    {
        try
        {
            int choice;

            do
            {
                System.out.print("Which operation: input (1); or output (2) ; or update (3) ==> ");
                choice = READER.nextInt();

                if (choice == 1)
                {
                    input();
                }
                else if (choice == 2)
                {
                    output();
                }
                else if (choice == 3)
                {
                    update();
                }

            } while (choice == 1 || choice == 2 || choice == 3);
        }

        catch (IOException ex)
        {
            System.out.println(ex);
        }

        catch (InputMismatchException ex)
        {
            System.out.println(ex);
        }

        catch (Exception ex)
        {
            System.out.println(ex);
        }
    }

    public static void output() throws IOException
    {
            RandomAccessFile studentFile = new RandomAccessFile("App_Data/credits.data", "rw");

            for (int counter = 0; counter < 5; counter++)
            {
                System.out.print("Enter number of credits==> ");
                int credits = READER.nextInt();
                studentFile.writeInt(credits);
            }

            studentFile.close();
    }

    public static void input() throws IOException
    {
            RandomAccessFile studentFile = new RandomAccessFile("App_Data/credits.data", "r");

            System.out.print("Enter student ID (1-5)==> ");
            long studentID = READER.nextLong();

            while (studentID >= 1 && studentID <= 5)
            {
                studentFile.seek( 4 * (studentID - 1) );

                int credits = studentFile.readInt();

                System.out.println("Student ID: " + studentID + "\nCredits: " + credits + "\n");

                System.out.print("Enter student ID (1-5)==> ");
                studentID = READER.nextLong();
            }

            studentFile.close();
    }

    public static void update() throws IOException
    {
            RandomAccessFile studentFile = new RandomAccessFile("App_Data/credits.data", "rw");

            System.out.print("Enter student ID (1-5)==> ");
            long studentID = READER.nextLong();

            studentFile.seek( 4 * (studentID - 1) );
            int credits = studentFile.readInt();

            System.out.println("Student ID: " + studentID + "\nCredits: " + credits + "\n");

            studentFile.seek( 4 * (studentID - 1) );

            System.out.print("Enter number of credits==> ");
            credits = READER.nextInt();

            studentFile.writeInt(credits);
            studentFile.close();
    }

}
